#include "mididev.h"

#include <cctype>

mididev::mididev() : timeractive(false)
{
#if defined(TIMIDITYHOST) && defined(TIMIDITYPORT)
    timidityconn[0].open(TIMIDITYHOST, TIMIDITYPORT);
    fd = timidityconn[0].getfd();
    if(fd >= 0)
    {
    	unsigned test = 0x1234;
    	
    	fcntl(fd, F_SETFL, fcntl(fd, F_GETFL) & ~O_NONBLOCK);
    	std::write(fd, "open ", 5);
    	
    	if(*(unsigned char *)&test == 0x34)
    	    std::write(fd, "lsb\n", 4);
    	else
    	    std::write(fd, "msb\n", 4);
    	
    	for(;;)
    	{
    		string tmp;
    		char c;
    		while(read(fd, &c, 1) && c != '\n')tmp += c;
    		if(tmp == "") { fd=-1; break; }
    		if(tmp.find("is ready") != tmp.npos)
    		{
    			unsigned a, n=0;
    			for(a=4; isdigit(tmp[a]); ++a)n=n*10+tmp[a]-'0';
    			timidityconn[1].open(TIMIDITYHOST, n);
    			fd = timidityconn[1].getfd();
    			break;
    		}
    	}
    }
	if(fd < 0)
#endif
	    fd = std::open("/dev/sequencer", O_WRONLY);
}
