#ifndef pokemud_mudconn_h
#define pokemud_mudconn_h

#include <sys/socket.h>
#include <netinet/in.h>
#include <sys/time.h>
#include <netdb.h>
#include <fcntl.h>

class mudconn
{
    int fd;
public:
    mudconn() : fd(-1)
    {
    }
    ~mudconn()
    {
        if(fd >= 0)close(fd);
    }
    void open(const char *host, int port=6134)
    {
        struct hostent *HostName;
        struct sockaddr_in SocketName;
        struct timeval tv = {10,0};
        fd_set fds;
        int plug;
        
        if(fd >= 0) { close(fd); fd = -1; }
        
        if((plug = socket(AF_INET,SOCK_STREAM,0)) < 0)return;
        
        HostName = gethostbyname(host);
        if(!HostName)return;
        
        SocketName.sin_family = AF_INET;
        SocketName.sin_port = htons(port);
        memcpy(&SocketName.sin_addr, HostName->h_addr, HostName->h_length);
        
        FD_ZERO(&fds);
        FD_SET(plug, &fds);
        
        fcntl(plug, F_SETFL, fcntl(plug, F_GETFL) | O_NONBLOCK);
    
        if(connect(plug, (struct sockaddr *)&SocketName, sizeof(SocketName)))
        {
            if(select(plug+1, &fds,&fds,NULL, &tv) <= 0
            || connect(plug, (struct sockaddr *)&SocketName, sizeof(SocketName)) < 0)
            {
                close(plug);
                return;
            }
        }
        
        fd = plug;
    }
    int getfd() const
    {
        return fd;
    }
};

#endif
