#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>

/*
	emotion levels:
	
		0 = Kachu...
		1 = Pika.
		2 = Pika-chu.
		3 = Pika-chu!
		4 = Pikapikachu!
		5 = Pikachu! Pikapika!
		4 = PIKA! Pikachu! Pikapipipi!
		5 = Pi! PIKA! PI-KA-CHU!!

*/
static void PrByte(int iso, int isoalku, const char *s)
{
	const char *q;
	for(q=s; *q; ++q)
		printf("%c", (iso||(q==s&&isoalku)) ? *q : tolower(*q));
}
static void PokeTalk(const char *s, int emotion)
{	
	static const char kons[] = "BCDFGHJKLMNPQRSTVWXZ%&";
	char *q = (char *)malloc(strlen(s)+1);
	const char *t;
	char *p, *r, **byt;
	int byco, br, bycomax;
	int alku, koo=0;
	int huu, iso;
	
	/* Create a table: Bulbasaur -> BULBASAUR, Farfetch'd -> FARFET%D */
	for(p=q, t=s; *t; ++t)
		if(isalpha(*t))
		{
			if((t[0]=='c'||t[0]=='C') && (t[1]=='h'||t[1]=='H'))
				*p++ = '%', ++t;
			else if((t[0]=='t'||t[0]=='T') && (t[1]=='h'||t[1]=='H'))
				*p++ = '&', ++t;
			else
				*p++ = toupper(*t);
		}
	
	*p=0;
	byco = strlen(q);
	byt = (char **)malloc(byco * sizeof(char *));
	
	for(p=r=q, alku=1, br=0; ; ++p)
	{
	/*	printf("Checking '%c'\n", *p);
	*/	if(alku)
		{
			koo=0;
			if(strchr(kons, *p))continue;
			alku=0;
		}
		if(!*p)goto Add;
		if(!strchr(kons, *p))
			koo=0;
		else
		{
		/*	printf("kOnschjeck\n"); -- typo++
		*/	if(!p[1] || !strchr(kons, p[1]) || ++koo>3)
			{
				if(!p[1])++p;
			Add:
				for(t=r, r=byt[br++]=(char *)malloc(p-r+5); t<p; ++t)
				{
					if(*t=='%'){*r++='C';*r++='H';}
					else if(*t=='&'){*r++='T';*r++='H';}
					else *r++ = *t;
				}
				*r=0;
			/*	printf("Made byte \"%s\"\n", byt[br-1]);
			*/	if(!*p)break;
				alku=1, koo=0;
				r=p--;
			}
		}
	}
	
	printf("<%s> ", s);
	
	bycomax = emotion/2;
	for(koo=1, byco=iso=huu=0; byco<1+bycomax; ++byco)
	{
		int c=byco<bycomax && rand()%3;
		int b, a = br - rand()%(1+rand()%br);
		if(koo)iso = rand()%(1+rand()%((emotion+8)/5));
		if(rand()%3)
		{
			/* Forwards */
			for(b=0; b<a; ++b)
				PrByte(iso, !b&&koo, byt[b]);
		}
		else
		{
			/* Backwards */
			for(c=b=0; b<a; ++b)
				PrByte(iso, !b&&koo, byt[b+br-a]);
		}
		if(c)
		{
			if(rand()%3)printf("-");
			koo = 0;
		}
		else
		{
			koo = 1;
			if(!emotion)
				printf("... ");
			else
			{
				if(!(b = emotion/5 + rand() % ((2+emotion)/3)) && huu && byco==bycomax)
					b = 1;
				if(!b)
					printf(".");
				else
				{
					if(b>3)b=3;
					for(huu=1, a=0; a<b; ++a)printf("!");
				}
				printf(" ");
			}
		}
	}
	printf("\n");
	
	for(alku=0; alku<br; ++alku)
		free(byt[alku]);
	
	free(q);
	free(byt);
}

int main(int argc, const char *const *argv)
{
	int emolevel=4;
	srand(time(0));
	if(!--argc)
	{
		printf("Usage: poketalk <pokmon name> [emotion level]\n");
		return -1;
	}
	if(--argc)emolevel=atoi(argv[2]);	
	PokeTalk(*++argv, emolevel);
	
	return 0;
}
